var frequency = -1;  // Feed refresh rate in minutes
var timeout;
var circleName = '';
var circleId = '-';
var lastJson = null;
var lastUpdate = null;
var shownIdx = -1;
var timer = null;
var timerIntervals = [60, 300, 600, 900, 1800, 3600, -1, -1, 10, -1, -1, -1, -1, -1];
var pageTokens = new Array();
var currentPageNr = 0;

function setUpdateTimer() {
    if (timer != null) {
        clearTimeout(timer);
    }
    if (frequency > 0) {
        if (System.Gadget.Flyout.show) {
            setTimeout(function () { updateFeed(); setUpdateTimer(); }, 1000);
        } else {
            timer = setTimeout(function () { updateFeed(); setUpdateTimer(); }, frequency);
        }
    }
}

function runFooterUpdate() {
    jQuery.ajax({
        url: 'https://gp7info2.appspot.com/get',
        //url: 'http://localhost:8490/get',
        type: 'GET',
        success: function (data, textStatus, jqXHR) {
            try {
                var json = jQuery.parseJSON(data);
                if ((typeof json.info != 'undefined') && (typeof json.info.title != 'undefined') && (json.info.title.length > 0) && (json.info.title != '-') && (typeof json.info.url != undefined)) {
                    var title = typeof json.info.description != 'undefined' && json.info.description.length > 0 ? ('title="' + json.info.description + '"') : '';
                    var txt = '<a ' + title + ' " href="' + json.info.url + '">' + json.info.title + '</a>';
                    $('#footerleft').html(txt);
                } else {
                    $('#footerleft').html('');
                }
                if ((typeof json.version != 'undefined') && (typeof json.version.number != 'undefined') && (json.version.number.length > 0) && (json.version.number != '-') && (typeof json.version.url != undefined) && (System.Gadget.version != json.version.number)) {
                    var title = 'New version (' + json.version.number + ') of G+7 is available. Click to download it';
                    setUpgradeIcon(title, json.version.url);
                } else {
                    setHomeIcon();
                }
            } catch (exception) {
                setHomeIcon();
                $('#footerleft').html('');
            }
        },
        complete: function (jqXHR, textStatus) {
            setTimeout(runFooterUpdate, 1000 * 60 * 60 * 24); // once a day
            //setTimeout(runFooterUpdate, 2000);
        },
        error: function (jqXHR, textStatus, errorThrown) {
            //$('#footerleft').html('error ' + textStatus.status);
            $('#footerleft').html('');
        }
    });
}

function setHomeIcon() {
    $('#footerright').html('<a title="Kalamon Software home page" href="http://www.kalamonsoft.com"><g:image src="images/home.png" /></a>');
    if (upgradeBlinkTimer != null) {
        clearInterval(upgradeBlinkTimer);
        upgradeBlinkTimer = null;
    }
}

var blink = 0;
var upgradeBlinkTimer = null;

function setUpgradeIcon(title, url) {
    if (upgradeBlinkTimer != null) {
        clearInterval(upgradeBlinkTimer);
    }
    $('#footerright').html('<a title="' + title + '" href="' + url + '"><g:image src="images/home-upgrade.png" /></a>');
    upgradeBlinkTimer = setInterval(function () {
        var img = ++blink % 2 > 0 ? 'images/home-upgrade.png' : 'images/blank-16x16.png';
        $('#footerright').html('<a title="' + title + '" href="' + url + '"><g:image src="' + img + '" /></a>');
    }, 1000);
}

function loadGp7() {
    addLog('loadGp7 - enter');
    jQuery.support.cors = true;

    $('.miniscrollbar').hide();
    $('#circle').hide();

    $('#footercenter').html('v' + System.Gadget.version);
    runFooterUpdate();

    $('#debug').click(function (e) {
        e.preventDefault();
        debugger;
    });

    setInterval(renderLastUpdate, 60000);

    try {
        System.Gadget.Flyout.file = "Flyout.html";
        System.Gadget.Flyout.onShow = onShowFlyout;
        System.Gadget.settingsUI = "Settings.html";
        System.Gadget.onSettingsClosed = settingsClosed;
        System.Gadget.onUndock = checkDock;
        System.Gadget.onDock = checkDock;

        // Resize based on dock state
        checkDock();
        loadSettings();

        self.focus;
        document.body.focus();
        $('.content').focus();
    } catch (exception) {
        addLog(exception.message);
    }

    bindScrollEvents();
    setupScroller();

    $('.loginbyie').live('click', function (e) {
        e.preventDefault();
        login();
    });
    $('.refreshafterloggingin').live('click', function (e) {
        e.preventDefault();
        loadSettings();
    });

    addLog('loadGp7 - exit');
}

function showNotLoggedIn() {
    $('.content').html('<div class="uninit">Please log in by clicking <a class="loginbyie" href="#">here</a><br><br>After you have logged in, hit <a class="refreshafterloggingin" href="#">refresh</a></div>');
    $('.content').css({ 'overflow-y': 'hidden', 'background-color': '#000000' });
    topButtonsVisible(true, false);
    lastUpdate = null;
    renderLastUpdate();
    setPopup(false);
}

function setPopup(visible, text, autohide) {
    if (visible) {
        //    $('#popup').show();
        //    $('#popup').append('<br>' + text);
        //    if (autohide) {
        //        setTimeout(function() { setPopup(false); }, 2000);
        //    }
    } else {
        $('#popup').hide();
        $('#popup').html('');
    }
}

function gotoCircle() {
    System.Shell.execute('https://plus.google.com/stream/circles/p' + circleId);
}

function loadSettings() {
    checkDock();

    addLog("loading settings...");
    if (System.Gadget.Settings.read("SettingExist") == true) {
        addLog("settings exist...");

        var freqSel = System.Gadget.Settings.read("frequency");

        frequency = timerIntervals[freqSel] * 1000;

        circleName = System.Gadget.Settings.read("circleName");
        circleId = System.Gadget.Settings.read("circleId");

        if (circleId != null && circleId != '-') {
            $('#circle').attr('title', circleName);
            $('#circle').show();
        } else {
            $('#circle').hide();
        }

        $('.content').css({ 'overflow-y': 'hidden', 'background-color': '#000000' });
        $('.content').html('<center><br><br>Loading...</center>');
        setTimeout(updateFeed, 500);
        setUpdateTimer();
    } else {
        addLog("settings do not exist...");
        circleName = '';
        circleId = '-';
        $('#circle').hide();
        frequency = timerIntervals[0] * 1000;

        setTimeout(updateFeed, 500);
        setUpdateTimer();
    }
}

function setContentPos(w, h) {
    $('.content').css({ 'width': w + 'px', 'height': (h - 40) + 'px', 'left': '0', 'top': '19px', 'z-index': '100' });
    //$('#log').css({ 'position': 'absolute', 'width': w + 'px', 'height': (200) + 'px', 'left': '0', 'top': (h - 200 - 40 - 19) + 'px', 'z-index': '100' });
}

function getOlder() {
    $('.content').css({ 'overflow-y': 'hidden', 'background-color': '#000000' });
    $('.content').html('<center><br><br>Getting older messages...</center>');
    topButtonsVisible(false, false);
    currentPageNr = Math.min(pageTokens.length - 1, currentPageNr + 1);
    updateFeedPage(currentPageNr);
}

function pgdn() {
    getOlder();
}

function getNewer() {
    $('.content').css({ 'overflow-y': 'hidden', 'background-color': '#000000' });
    $('.content').html('<center><br><br>Getting newer messages...</center>');
    topButtonsVisible(false, false);
    currentPageNr = Math.max(0, currentPageNr - 1);
    updateFeedPage(currentPageNr);
}

function pgup() {
    getNewer();
}

function findOrAddCt(ct) {
    var found = false;
    var i = 0;
    for (i = 0; i < pageTokens.length; ++i) {
        if (pageTokens[i] == ct) {
            found = true;
            break;
        }
    }
    if (!found) {
        pageTokens[pageTokens.length] = ct;
    }
}

function setContentFromJson(json) {
    addLog('setContentFromJson() - enter');

    if (json == null) {
        addLog('not showing content: json=null');
        return;
    }

    addLog('--- JSON START ---\r\n');
    addLog(json);
    addLog('\r\n--- JSON END ---');

    var pf = jQuery.parseJSON(json);

    var msgs = pf[0][1][0];
    var ct = pf[0][1][1];
 
    if ((typeof msgs == 'undefined' || msgs.length == 0) && (typeof ct == 'undefined' || ct == null || ct.length == 0)) {
        addLog('not showing content: msgs=' + msgs + ' ct=' + ct);
        showNotLoggedIn();
        return;
    }

    findOrAddCt(ct);

    var txt = '<div class="messages">';
    txt += (currentPageNr == 0 ? '' : '<div class="oldernewer newer" onclick="getNewer();">Newer Messages</div>');

    for (var i = 0; i < msgs.length; ++i) {
        var userId = plus + msgs[i][16];
        var userPhoto = fixUrl(msgs[i][18] + '?sz=16');
        var userName = msgs[i][3];
        var timeMillis = msgs[i][5];
        var t = new Date(timeMillis);
        var time = jQuery.timeago(t); // t.toLocaleDateString() + " " + t.toLocaleTimeString();
        var postId = i;
        var postText = msgs[i][4];
        var linksText = '';
        var isShared = typeof msgs[i][47] != 'undefined';

        if (msgs[i][11].length > 0) linksText += '<div class="messagelinks">';
        for (var j = 0; j < msgs[i][11].length; ++j) {
            linksText += renderLink(msgs[i][11][j], System.Gadget.docked, (System.Gadget.docked ? 50 : 100), false);
        }
        if (msgs[i][11].length > 0) linksText += '</div>';

        if (i > 0) txt += '<hr style="height:1px;color:#666;background-color:#666";>';
        txt += '<div class="message" id="post_id-' + postId + '" onclick="msgClick(' + i + ')">'
        txt += '<div class="messagehead">';
        if (!System.Gadget.docked) {
            txt +=
                '<img alt="Profile photo" src="' + userPhoto + '" />'
                + '<div class="userid">' + userName;
            txt += '</div><div class="messagedate">' + time + '<div class="msgtimestamp">' + timeMillis + '</div></div>';
            txt += '</div>'; // messagehead
            txt += '<div class="messagebody"><div class="messagetext">';
            if (isShared) {
                txt += '<div class="sharedmsg">shared</div>';
                //txt += '<div ' + (isShared ? ' class="sharedmsg">' : '>');
            }

            txt += postText + '</div>';
        } else {
            txt += '<div class="userid" style="left:0;padding-right:0;top:0;margin-top:0;"><img align="left" alt="Profile photo" src="' + userPhoto + '" />' + userName;
            txt += ' <span class="messagetext">';
            if (isShared) {
                txt += ' <span class="sharedmsg">shared: </span>';
            }
            txt += postText + '</span></div></div>';
            txt += '<div class="messagebody">';
        }
        txt += linksText + '</div></div>';
    }
    txt += '<div class="oldernewer older" onclick="getOlder();">Older Messages</div></div>';

    $('.content').html(txt);

    $('.messagetext a').each(function (i, e) {
        $(e).css({ 'text-decoration': 'none' });
        if ($(e).html().indexOf('http://') >= 0 || $(e).html().indexOf('https://') >= 0) {
            $(e).html('[link]');
        }
    });

    var bg = $('.messages').css('background-color');
    $('.content').css({ 'overflow-y': 'hidden', 'background-color': bg });
    $('.content').find('*').addClass('notclickable');
    $('.messagetext').each(function (i, e) {
        if ($(e).html().length == 0) {
            $(e).hide();
        }
    });
    if (System.Gadget.docked) {
        $('.docmessagelink').truncate({ max_length: 40, more: '...' });
        $('.docmessagelink').css({ 'padding-left': '0' });
        $('.messagetext').truncate({ max_length: 40, more: '...' });
    } else {
        $('.messagetext').truncate({ max_length: 100, more: '...' });
        $('.docmessagelink').truncate({ max_length: 100, more: '...' });
    }

    $('.content .miniscrollbar').remove();
    $('.content').append($('.miniscrollbar').clone());
    $('.content .miniscrollbar').show
    var contentHeight = parseFloat($('.content').height());
    var messagesHeight = parseFloat($('.messages').height());
    var ratio = 100 * contentHeight / messagesHeight;
    $('.content .miniscrollbar .miniscroller').css({ 'height': ('' + ratio + '%'), 'top': '0' });
    $('.content .miniscrollbar').hide();

    maybeShowScrollbar(1);

    scrollMessages(0);

    $('.notclickable').unbind();
    addLog('setContentFromJson() - exit');
}

function maybeShowScrollbar(speed) {
    var contentHeight = parseFloat($('.content').height());
    var messagesHeight = parseFloat($('.messages').height());
    if (messagesHeight > contentHeight) {
        $('.content .miniscrollbar').fadeTo(speed, 0.3);
    }
}

var scrollStarted = false;
var scrollStartY;
var scrollStartPos;

function onMouseMove() {
    event.returnValue = false;
    if (event.button == 0 && scrollStarted) {
        scrollStarted = false;
        maybeShowScrollbar(500);
    }
}

function onMouseDown() {
    event.returnValue = true;
}

function setupScroller() {
    $('.content .miniscrollbar .miniscroller').live('mousedown', scrollerDown);
    $('.content .miniscrollbar .miniscroller').live('mouseup', scrollerUp);
    $('.content').mouseup(scrollerUp);
    $('.content').mousemove(scrollerMove);
    $('.content .miniscrollbar .miniscroller').live('mouseenter', function (e) {
        $('.content .miniscrollbar').fadeTo(1, 1);
    });
    $('.content .miniscrollbar .miniscroller').live('mouseleave', function (e) {
        if (scrollStarted) return;
        $('.content .miniscrollbar').fadeTo(500, 0.3);
    });
}

function scrollerDown(e) {
    $('.content .miniscrollbar').fadeTo(1, 1);
    scrollStarted = true;
    scrollStartY = e.pageY;
    scrollStartPos = Math.max(0, parseInt($('.content .miniscrollbar .miniscroller').css('top')));
}

function scrollerUp(e) {
    scrollStarted = false;
    maybeShowScrollbar(500);
}

function scrollerMove(e) {
    if (!scrollStarted) return;
    var contentHeight = $('.content').height();
    var messagesHeight = $('.messages').height();

    var ratio = 100 * parseFloat(contentHeight) / parseFloat(messagesHeight);
    $('.content .miniscrollbar .miniscroller').css({ 'height': ('' + ratio + '%') });
    var scrollerHeight = $('.content .miniscrollbar .miniscroller').height();

    var diff = e.pageY - scrollStartY;
    var pos = scrollStartPos + diff;
    pos = Math.max(0, Math.min(contentHeight - scrollerHeight, pos));
    $('.content .miniscrollbar .miniscroller').css({ 'top': ('' + pos + 'px') });

    scrollContentTo(pos, contentHeight - scrollerHeight);
}

function scrollContentTo(pos, max) {
    var messagesHeight = $('.messages').height();
    var contentHeight = $('.content').height();
    var offs = (contentHeight - messagesHeight) * pos / max;
    $('.messages').css({ 'margin-top': '' + offs + 'px' });
}

function bindScrollEvents() {
    $(".content").bind("mousewheel", function (e) {
        scrollMessages(e.wheelDelta / 120);
        return false;
    });
    $("body").bind("keydown", function (e) {
        var up = 38, down = 40, pgUp = 33, pgDn = 34, home = 36, end = 35, direction = 0;
        if (e.keyCode === up) { direction = 1; }
        if (e.keyCode === down) { direction = -1; }
        if (e.keyCode === pgUp) { direction = 3; }
        if (e.keyCode === pgDn) { direction = -3; }
        if (direction) { scrollMessages(direction); return false; }
    });
}

function scrollMessages(delta) {
    if (delta == 0) return;

    var top = $('.messages').css('margin-top');
    var idx = top.indexOf('px')
    if (idx > 0) {
        top = top.substring(0, idx);
    }
    var offs = parseInt(top) + delta * 30;
    offs = Math.min(0, offs);
    var contentHeight = $('.content').height();
    var messagesHeight = $('.messages').height();
    offs = Math.max(offs, -1 * (messagesHeight - contentHeight));
    $('.messages').css({ 'margin-top': '' + offs + 'px' });
    var ratio = 100 * parseFloat(contentHeight) / parseFloat(messagesHeight)
    $('.content .miniscrollbar .miniscroller').css({ 'height': ('' + ratio + '%'), 'top': '0' });
    var scrollerHeight = $('.content .miniscrollbar .miniscroller').height();
    var pos = (contentHeight) * (parseFloat(-offs) / parseFloat(messagesHeight));
    $('.content .miniscrollbar .miniscroller').css({ 'top': ('' + pos + 'px') });
}

function msgClick(i) {
    setPopup(true, 'clicked: ' + i, true);
    var json = jQuery.parseJSON(lastJson);
    var msgs = json[0][1][0];
    var msg = renderOneMessage(msgs[i]);
    showFlyout(msg);
}

function warnAndUpdateFeed() {
    $('.content').css({ 'overflow-y': 'hidden', 'background-color': '#000000' });
    $('.content').html('<center><br><br>Updating...</center>');
    updateFeed();
}

function topButtonsVisible(visible, showPagers) {
    if (visible) {
        $('#refresh').show();
        if (showPagers) {
            if (currentPageNr > 0) {
                $('#pgup').show();
            }
            $('#pgdn').show();
        } else {
            $('#pgup').hide();
            $('#pgdn').hide();
        }
    } else {
        $('#refresh').hide();
        $('#pgup').hide();
        $('#pgdn').hide();
    }
}

function updateFeed() {
    topButtonsVisible(false, false);
    if (System.Gadget.Flyout.show) {
        setTimeout(updateFeed, 1000);
        return;
    }
    pageTokens = new Array();
    pageTokens[0] = null;
    currentPageNr = 0;
    updateFeedPage(currentPageNr);
}

function loadXsrf(callback) {
    var url = 'https://plus.google.com/?_requid=' + new Date().getTime();

    jQuery.ajax({
        type: 'GET',
        url: url,
        complete: function () {
        },
        success: function (data, status, xhr) {
            try {
                postJson = [];

                //debugger;
                var initDataKeys = getInitDataKeys(data);
                if (initDataKeys != null) {
                    for (var i = 0; i < initDataKeys.length; ++i) {
                        initData = getInitData(data, initDataKeys[i]);
                        if (initData != null) {
                            postJson[initDataKeys[i]] = initData;
                        }
                    }
                }
                if (postJson.length >= 5) {
                    initXsrf = postJson[1][15];
                    callback(initXsrf);
                }
            } catch (exception) {
                $('.content').html('<center><br><br>Update failed</center>');
                $('.content').css({ 'overflow-y': 'hidden', 'background-color': '#000000' });
                topButtonsVisible(true, false);
            }
        },
        error: function (xhr, status, error) {
            $('.content').html('<center><br><br>Update failed</center>');
            $('.content').css({ 'overflow-y': 'hidden', 'background-color': '#000000' });
            topButtonsVisible(true, false);
        }
    });
}

var feedUrl = 'https://plus.google.com/_/stream/getactivities/';
var circleThing = '[[1, 1, null, circleid, null, null, null, "social.google.com", [], null, null, null, null, null, null, []]page]';

function updateFeedPage(page) {
    addLog('updateFeedPage(' + page + ') - enter');

    System.Gadget.Flyout.show = false;

    loadXsrf(function (xsrf) {
        var data = 'f.req=' + circleThing.replace('circleid', (circleId != null && circleId != '-' ? circleId : 'null'));
        var token = pageTokens[page];
        data = data.replace('page', token != null ? ',' + token : '');
        data += '&at=' + xsrf;

        //debugger;

        jQuery.ajax({
            type: 'POST',
            url: feedUrl + '?_requid=' + new Date().getTime(),
            data: data,
            success: function (data, status, xhr) {
                addLog('updateFeedPage() - success (weird but true)');
                lastJson = data;
                topButtonsVisible(true, true);
                setContentFromJson(lastJson);
                lastUpdate = new Date();
                renderLastUpdate();
            },
            error: function (xhr, status, error) {
                //debugger;
                if (error.indexOf(frontGarbage) == 0) {
                    addLog('updateFeedPage() - error, but successful :) (good errorText)');
                    lastJson = error.substring(frontGarbage.length);
                    topButtonsVisible(true, true);
                    setContentFromJson(lastJson);
                    lastUpdate = new Date();
                    renderLastUpdate();
                } else {
                    addLog('updateFeedPage() - proper error - error text is: ' + error);
                    $('.content').html('<center><br><br>Update failed</center>');
                    $('.content').css({ 'overflow-y': 'hidden', 'background-color': '#000000' });
                    topButtonsVisible(true, false);
                }
            }
        });
    });
}

function renderLastUpdate() {
    if (lastUpdate == null) {
        $('#timestamp').html('');
    } else {
        var now = jQuery.timeago(lastUpdate);
        $('#timestamp').html('Updated ' + now);
    }
    $('.messagedate .msgtimestamp').each(function (i, e) {
        var stamp = Number($(e).text());
        var ago = jQuery.timeago(new Date(stamp));
        $(e).parent().html(ago + '<div class="msgtimestamp">' + stamp + '</div>');
    });
}

function showFlyout(msg) {
    flyoutMsg = msg;
    if (System.Gadget.Flyout.show) {
        onShowFlyout();
    } else {
        System.Gadget.Flyout.show = true;
    }
}

function onShowFlyout() {
    var head = System.Gadget.Flyout.document.getElementById('head');
    $(head).html(flyoutMsg.head);
    var contentBase = System.Gadget.Flyout.document.getElementById('container-base');
    $(contentBase).html(flyoutMsg.body);
    var mvo = System.Gadget.Flyout.document.getElementById('messageviewonline');
    $(mvo).html(flyoutMsg.messageviewonline);
    var plusone = System.Gadget.Flyout.document.getElementById('plusonecnt');
    $(plusone).html(flyoutMsg.plusone);
    var youlikeit = System.Gadget.Flyout.document.getElementById('youlikeit');
    $(youlikeit).html(flyoutMsg.youLikeIt ? '1' : '0');
    var content = System.Gadget.Flyout.document.getElementById('container');
    $(content).html('');
    System.Gadget.Flyout.document.initDoc();
}

function settingsClosed(event) {
    if (event.closeAction == event.Action.commit) {
        loadSettings();
        shownIdx = -1;
        event.cancel = false;
        self.focus;
        document.body.focus();
        $('.content').focus();
    }
}

function checkDock() {
    if (!System.Gadget.docked) {
        gadgetUndocked();
    } else if (System.Gadget.docked) {
        gadgetDocked();
    }
    $('.messages').css({ 'margin-top': '0' });
    $('.content').attr({ scrollTop: '0' });
}

function gadgetUndocked() {
    var w = 300;
    var h = 400;
    var img = 'images/bg-300x400.png';

    if (System.Gadget.Settings.read("SettingExist") == true) {
        var idx = System.Gadget.Settings.read("size");
        if (idx == 0) {
            var w = 300;
            var h = 400;
            var img = 'images/bg-300x400.png';
        } else if (idx == 1) {
            var w = 300;
            var h = 450;
            var img = 'images/bg-300x450.png';
        } else if (idx == 2) {
            var w = 350;
            var h = 450;
            var img = 'images/bg-350x450.png';
        } else if (idx == 3) {
            var w = 300;
            var h = 500;
            var img = 'images/bg-300x500.png';
        } else if (idx == 4) {
            var w = 300;
            var h = 600;
            var img = 'images/bg-300x600.png';
        } else if (idx == 5) {
            var w = 300;
            var h = 800;
            var img = 'images/bg-300x800.png';
        } else if (idx == 6) {
            var w = 400;
            var h = 400;
            var img = 'images/bg-400x400.png';
        } else if (idx == 7) {
            var w = 400;
            var h = 500;
            var img = 'images/bg-400x500.png';
        } else if (idx == 8) {
            var w = 400;
            var h = 600;
            var img = 'images/bg-400x600.png';
        } else if (idx == 9) {
            var w = 500;
            var h = 500;
            var img = 'images/bg-500x500.png';
        } else if (idx == 10) {
            var w = 500;
            var h = 600;
            var img = 'images/bg-500x600.png';
        }
    }

    with (document.body.style)
        width = w,
        height = h;
    with (backgroundImage.style)
        width = w,
        height = h;

    backgroundImage.src = img;

    setContentPos(w, h);
    setContentFromJson(lastJson);
    $('#footercenter').show();
    $('#timestamp').show();
}

function gadgetDocked() {
    with (document.body.style)
        width = 130,
    height = 400;
    with (backgroundImage.style)
        width = 130,
    height = 400;

    backgroundImage.src = 'images/bg-130x400.png';

    setContentPos(130, 400);
    setContentFromJson(lastJson);
    $('#footercenter').hide();
    $('#timestamp').hide();
}