﻿var plus = 'https://plus.google.com/';
var frontGarbage = "Invalid JSON: )]}'";

function fixUrl(txt) {
    if (txt.indexOf('https:') < 0) {
        return 'https:' + txt;
    }
    return txt;
}

function login() {
    try {
        System.Shell.execute("\"" + System.Gadget.path + "\\bin\\GoogleAUthenticator.exe\"");
    } catch (exception) {
        addLog(exception.message);
    }
}

function getSizedImage(imgUrl, size) {
    return 'https://images1-focus-opensocial.googleusercontent.com/gadgets/proxy?url=' + encodeURIComponent(imgUrl) + '&container=focus&gadget=a&rewriteMime=image/*&refresh=31536000&resize_w=' + size + '&no_expand=1';
}

function renderLink(link, docked, imgsize, addLinks) {
    var title = link[3];
    var url = link[24][1];
    var type = link[24][4];
    var thumb = typeof link[41] != 'undefined' ? link[41][0][1] : null;
    if (typeof title == 'undefined') {
        title = '';
    } else {
        var linkedTitle = addLinks ? ('<a href="' + url + '">' + title + '</a>') : title;
        title = '<div><strong>' + linkedTitle + '</strong></div>';
    }
    var descr = link[21];
    if (typeof descr == 'undefined') {
        descr = '';
    } else {
        descr = '<div class="docmessagelink">' + descr + '</div>';
    }
    if (type == 'document') {
        if (docked)
            return '<div class="messagelink docmessagelink">' + title + '</div>';
        else
            return '<div class="messagelink">' + title + descr + '</div>';
    }
    var res = '<div class="messagelink">';
    if (addLinks) {
        res += '<a href="' + url + '">';
    }
    if (thumb) {
        res += '<img src="' + getSizedImage(thumb, imgsize) + '">';
    }
    if (addLinks) {
        res += '</a>';
    }
    res += '<span class="docmessagelink">' + title + '</span>';
    if (docked) {
        res += descr;
    }
    res += '</div>';

    return res;
}

function renderComments(msg) {
    if (msg[7] == null || msg[7].length == 0) return '';
    var cmtsCnt = msg[93];
    var txt = '<div class="messagecomments">';
    //if (cmtsCnt > 2) {
    //    txt += 'Last 2 comments of ' + cmtsCnt;
    //} else {
    txt += 'Comments (' + msg[7].length + ')';
    //}
    for (var i = 0; i < msg[7].length; ++i) {
        txt +=
            '<div class="messagecomment">'
                + '<div class="commenthead">'
                    + '<img class="img" src="' + fixUrl(msg[7][i][16] + '?sz=16') + '" />'
                    + '<a href="' + plus + msg[7][i][6] + '/posts"> ' + msg[7][i][1] + '</a>'
                    + '<div class="commentdate">' + jQuery.timeago(new Date(msg[7][i][3])) + '</div>'
                + '</div>'
                + '<div class="commentbody">' + msg[7][i][2] + '</div>'
            + '</div>';
    }
    txt += '</div>';
    return txt;
}

function renderOneMessage(msg) {
    var head = '';
    var txt = '';
    var userId = plus + msg[16];
    var userPhoto = fixUrl(msg[18] + '?sz=48');
    var userName = msg[3];
    var timeMillis = msg[5];
    var t = new Date(timeMillis);
    var time = jQuery.timeago(t);
    var postText = msg[4];
    var postComments = renderComments(msg);
    var linksText = '';
    var location = msg[27];
    var locTxt = '';
    var likeCnt = msg[73][16];
    var shareCnt = msg[25].length;
    var shareMsg = msg[47];
    var originalSharer = typeof msg[44] != 'undefined' ? { 'name': msg[44][0], 'id': msg[44][1], 'photo': msg[44][4]} : null;
    var youLikeIt = typeof msg[73][9] != 'undefined';
    if (typeof location != 'undefined') {
        var locImg = location[10];
        var locMap = location[8]
        var locName = location[3];
        locTxt =
            '<div class="location">'
                + '<div class="locimg"><a class="location" href="' + locMap + '"><img width=50 height=50 style="border-style:none" src="' + locImg + '"/></a></div>'
                + '<a href="' + locMap + '" class="locationpin"></a>'
                + '<div class="locname"><a class="location" href="' + locMap + '">' + locName + '</a></div>'
            + '</div>';
    }
    if (msg[11].length > 0) linksText += '<div class="messagelinks">';
    for (var j = 0; j < msg[11].length; ++j) {
        linksText += renderLink(msg[11][j], false, 300, true);
    }
    if (msg[11].length > 0) linksText += '</div>';
    head += '<img class="img" alt="Profile photo" src="' + userPhoto + '" />&nbsp;<a class="userid" style="color:white;" href="' + userId + '">' + userName + '<a>' + '<div class="messagedate">' + time + '</div>';
    txt += '<div class="message"><div class="messagetext">';
    if (typeof shareMsg != 'undefined' && shareMsg.length > 0) {
        txt += shareMsg;
    }
    if (originalSharer != null) {
        txt += '<div class="sharedmsg"><img class="img" alt="Profile photo" src="' + fixUrl(originalSharer['photo'] + '?sz=16') + '" />&nbsp;<a class="sharinguserid" href="' + plus + originalSharer['id'] + '">' + originalSharer['name'] + '<a><span class="originalsharing"> originally shared this post</span><br/>';
    }
    txt += postText;
    if (originalSharer != null) {
        txt += '</div>';
    }
    txt += '</div>' + locTxt + linksText + postComments + '</div></div>';

    return {
        id: msg[8],
        head: head,
        body: txt,
        messageviewonline: '<a href="' + plus + msg[21] + '">View online</a>',
        plusone: likeCnt,
        youLikeIt: youLikeIt,
        shareCnt: shareCnt,
        originalSharer: originalSharer,
        shareMsg: shareMsg
    };
}

var circlesUrl = 'https://plus.google.com/_/socialgraph/lookup/circles/?rt=j';

function getCircles(onSuccess, onError) {
    var url = circlesUrl + '&_requid=' + new Date().getTime();

    jQuery.ajax({
        type: 'GET',
        url: url,
        success: function (data, status, xhr) {
            if (onError) onError();
            $('.circleswrap').hide();
        },
        error: function(xhr, status, error) {
            if (error.indexOf(frontGarbage) == 0) {
                var json = error.substring(frontGarbage.length);
                var circles = jQuery.parseJSON(json);
                if (onSuccess) {
                    onSuccess(circles);
                }
            } else {
                if (onError) onError();
            }
        }
    });

}

function getInitDataKeys(text) {
    //debugger;
    try {
        var start = text.indexOf('AF_initDataKeys = ');
        if (start > 0) {
            var sub = text.substring(start + 'AF_initDataKeys = '.length);
            var end = sub.indexOf(';');
            var t = sub.substring(0, end);
            var json = jQuery.parseJSON(t);
            return json;
        }
    } catch (exception) {
    }
    return null;
}

function getInitData(text, idx) {
    try {
        //var keyText = "AF_initDataQueue.push({key: '" + idx + "', data: ";
        var keyText = "AF_initDataCallback({key: '" + idx + "', isError:  false , data: ";
        var start = text.indexOf(keyText);
        if (start > 0) {
            var sub = text.substring(start + keyText.length);
            var end = sub.indexOf('});</script>');
            var t = sub.substring(0, end);
            var json = jQuery.parseJSON(t);
            return json;
        }
    } catch (exception) {
    }
    return null;
}